% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/EFAtools-package.R
\docType{package}
\name{EFAtools-package}
\alias{EFAtools}
\alias{EFAtools-package}
\title{EFAtools: Fast and Flexible Implementations of Exploratory Factor Analysis Tools}
\description{
Provides functions to perform exploratory factor analysis (EFA) procedures and compare their solutions. The goal is to provide state-of-the-art factor retention methods and a high degree of flexibility in the EFA procedures. This way, for example, implementations from R 'psych' and 'SPSS' can be compared. Moreover, functions for Schmid-Leiman transformation and the computation of omegas are provided. To speed up the analyses, some of the iterative procedures, like principal axis factoring (PAF), are implemented in C++.
}
\seealso{
Useful links:
\itemize{
  \item \url{https://github.com/mdsteiner/EFAtools}
  \item Report bugs at \url{https://github.com/mdsteiner/EFAtools/issues}
}

}
\author{
\strong{Maintainer}: Markus Steiner \email{markus.d.steiner@gmail.com}

Authors:
\itemize{
  \item Silvia Grieder \email{silvia.grieder@gmail.com}
}

Other contributors:
\itemize{
  \item William Revelle [contributor]
  \item Max Auerswald [contributor]
  \item Morten Moshagen [contributor]
  \item John Ruscio [contributor]
  \item Brendan Roche [contributor]
  \item Urbano Lorenzo-Seva [contributor]
  \item David Navarro-Gonzalez [contributor]
}

}
\keyword{internal}
